<?php
/**
 * Created by PhpStorm.
 * User: zhuangxin
 * Date: 16-9-22
 * Time: 上午10:12
 */

namespace App\Http\Controllers;


use App\Exceptions\ApiNotFound;
use App\Exceptions\ApiUnauthorized;
use App\Lib\Response\Response;
use \Illuminate\Http\Request;
use \Closure;


class ControllerBase
{
    public function getAuth()
    {
        return 12;
        static $id;
        if (!$id) {
            $code = request()->header("token");
            $client = app("client");
            $client->setUrl("user/getid/" . $code);
            $client->setMethod("get");
            $id = $client->curl();
        }
        return $id;
    }

    public function index($query = "")
    {
        empty($query) && $query = request()->getQueryString();
        try {
            $client = app("client");
            $uid = $this->getAuth();
            $query .= "&uid=".$uid;
            $client->setUrl($this->prefix."?".$query);
            $client->setMethod("get");
            $res = $client->curl();
            return Response::success($res);
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }

    public function store(Request $request)
    {
        try {
            $client = app("client");
            $client->setMethod("post");
            $post = array_merge($request->all(),['uid' => $this->getAuth()]);
            $client->setData($post);
            $client->setUrl($this->prefix);
            $client->curl();
            return Response::ok();
        } catch (ApiUnauthorized $e) {
            return Response::error($e->getMessage(), HttpStatus::HttpUnauthorized);
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }

    public function update($id,Request $request)
    {
        try {
            $this->isAllowed($id);
            $client = app("client");
            $client->setMethod("put");
            $post = array_merge($request->all(),['uid' => $this->getAuth()]);
            $client->setData($post);
            $client->curl();
            return Response::ok();
        } catch (ApiUnauthorized $e) {
            return Response::error($e->getMessage(), HttpStatus::HttpUnauthorized);
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }

    public function show($id,$query = "")
    {
        try {
            $client = app("client");
            $url = $this->prefix."/".$id;
            if (!empty($query)) {
                $url .= "?".$query;
            }
            $client->setUrl($url);
            $client->setMethod("get");
            $res = $client->curl();
            $this->isAllowed($id , $res);
            return Response::success($res);
        } catch (ApiUnauthorized $e) {
            return Response::error($e->getMessage(), HttpStatus::HttpUnauthorized);
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }

    public function prop($id,$key,$value)
    {
        $client = app("client");
        $client->setUrl($this->prefix."/".$id);
        $client->setMethod("put");
        $client->setData([$key => $value]);
        $res = $client->curl();
        return $res;
    }

    protected function isAllowed($id,$data = [])
    {
        $uid = $this->getAuth();
        $result = false;
        if (!empty($data)) {
            $result = ($data->uid == $uid);
        } else {
            $client = app("client");
            $client->setUrl($this->prefix."/".$id);
            $client->setMethod("get");
            $res = $client->curl();
            $result = ($res->uid == $uid);
        }
        if ($result == false) {
            throw new ApiNotFound("未找到");
        }
    }

    protected function combine(array $arr)
    {
        $query = request()->getQueryString();
        $res = [];
        foreach($arr as $k => $item)
        {
            $res[] = $k."=".$item;
        }
        return $query . "&" .implode("&",$res);
    }

    protected function filter($data,$func)
    {
        $result = [];
        foreach ($data as $item) {
            if (call_user_func($func,$item)) {
                $result[] = $item;
            }
        }
        return $result;
    }
}