<?php

namespace App\Http\Controllers\Sets\Controller;

use App\Exceptions\ApiNotFound;
use App\Exceptions\ApiUnauthorized;
use App\Http\Controllers\ControllerBase;
use Illuminate\Routing\Controller;
use App\Lib\Response\Response;
use Illuminate\Http\Request;

class Sets extends ControllerBase
{

    protected $prefix = "sets";


    //上下架
    public function shelf_up($id)
    {
        try {
            $this->isAllowed($id);
            $this->prop($id,"is_shelf",0);
            return Response::ok();
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }
    
    //上架
    public function shelf_down($id)
    {
        try {
            $this->isAllowed($id);
            $this->prop($id,"is_shelf",1);
            return Response::ok();
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }


}